## es_qwen2 instructions

1. Install qwen2 deb
    sudo apt install es-sdk-sample-npu-qwen
    notice: for deepseek based on release-2025-130, we need to update qwen deb and dsp deb.
    sudo dpkg -i es-sdk-sample-npu-qwen_1.4.0_riscv64.deb
    sudo dpkg -i es-sdk-dsp_1.4.0_riscv64.deb

2. How to build?
    cd ${qwen2_src} (The qwen2 src is in /opt/eswin/sample-code/npu_sample/qwen_sample/src after installed qwen2 deb).
    export CROSS_COMPILE=${cross_compile_prefix}
    ./build.sh --sys_root=<sys_root_dir> --prefix=<install_prefix>

    notice: ${cross_compile_prefix} can set to /usr/bin/ on the board or your CROSS_COMPILE path like this(/host/bin/riscv64-unknown-linux-gnu-) for cross compile.

3. Model deployment
    1) Download models of qwen2 from ftp.
        There are qwen2_0_5b and qwen2_7b in ftp. For example of qwen2_0_5b downloading:
        1. install ftp in board
            sudo apt install ftp
        2. Enter ftp command line
            ftp
        3. open ftp in ftp cmd line
            open ftp.eswin.com 2183
        4. enter username and password in ftp cmd line
            username: eic77xx-llm
            password: 87RM325t
        5. list all files and enter qwen2 directory
            ls
            cd qwen2
        6. list all files, There should be two files, qwen2_0_5b.tar.gz and qwen2_7b.tar.gz
            ls
        7. set local download directory
            lcd /opt/eswin/sample-code/npu_sample/qwen_sample/models
        8. download qwen2_0_5b.tar.gz
            mget qwen2_0_5b.tar.gz
        9. exit ftp and extract models
            exit
            cd /opt/eswin/sample-code/npu_sample/qwen_sample/models
            tar -xzf qwen2_0_5b.tar.gz
        notice: There are qwen2_0_5b.tar.gz, qwen2_7b.tar.gz, qwen2_0_5b_fp16.tar.gz, qwen2_0_5b_int8.tar.gz,
        qwen2_7b_int8.tar.gz, deepseek_r1_distill_qwen_7b_v0.1.tar.gz now. qwen2_0_5b.tar.gz and qwen2_7b.tar.gz is
        based on release-1230. qwen2_0_5b_fp16.tar.gz, qwen2_0_5b_int8.tar.gz, qwen2_7b_int8.tar.gz, deepseek_r1_distill_qwen_7b_v0.1.tar.gz is based on release-2025-130.

        qwen2_7b need 32G dram of board which need replace dtb in board. For example of eic7700-dvb,
        1. modify linux-6.6/arch/riscv/boot/dts/eswin/eic7700-hifive-premier-p550.dts
            a. Adjust MEMORY_SIZE_H from 0x4 to 0x8
            b. Adjust mmz reserved memory from 6G to 20G.

            --- a/arch/riscv/boot/dts/eswin/eic7700-hifive-premier-p550.dts
            +++ b/arch/riscv/boot/dts/eswin/eic7700-hifive-premier-p550.dts
            @@ -24,7 +24,7 @@
            #define LSPCLK_FREQ            200000000

            /* If wanna enable ECC capability of DDR, should reserve highest zone of 1/8 all space for it */
            - #define MEMORY_SIZE_H          0x4
            + #define MEMORY_SIZE_H          0x8
            #define MEMORY_SIZE_L          0x0
            #define CMA_SIZE               0x20000000

            @@ -111,7 +111,7 @@ g2d_12GB_boundary_reserved_4k {

                            mmz_nid_0_part_0 {
                                    compatible = "eswin-reserve-memory";
            -                       reg = <0x3 0x0 0x1 0x80000000>;
            +                       reg = <0x3 0x0 0x5 0x00000000>;
                                    no-map;
                            };
                    };
        2. Compile the eic7700-hifive-premier-p550.dts to generate eic7700-hifive-premier-p550.dtb.
        3. Replace eic7700-hifive-premier-p550.dtb to /boot/dtbs/linux-image-6.6.18/eswin/eic7700-hifive-premier-p550.dtb on board.
        4. sync and reboot the board.

    2) Copy models to board.
        examples: cp -r ${qwen2_0_5b} /opt/eswin/sample-code/npu_sample/qwen_sample/models/
                  cp -r ${qwen2_7b} /opt/eswin/sample-code/npu_sample/qwen_sample/models/

4. How to run es_qwen2?
    1) The binary es_qwen2 is installed in /opt/eswin/sample-code/npu_sample/qwen_sample/bin/.
    2) Adjust config.json for es_qwen2.
        The es_qwen2 uses config.json to specify model directory, model name, path of qwen.tiktoken and path of
        embedding.bin. The qwen.tiktoken is used for tokenization, the embedding.bin is used for generating embedding
        vector. User can modify the config.json through own configurations.
        For example:
            "model_dir": "/opt/eswin/sample-code/npu_sample/qwen_sample/models/qwen2_0_5b/",
            "block_models": [
                "modified_block_0_npu_b1.model",
                "modified_block_1_npu_b1.model",
                "modified_block_2_npu_b1.model",
                "modified_block_3_npu_b1.model",
                "modified_block_4_npu_b1.model",
                "modified_block_5_npu_b1.model",
                "modified_block_6_npu_b1.model",
                "modified_block_7_npu_b1.model",
                "modified_block_8_npu_b1.model",
                "modified_block_9_npu_b1.model",
                "modified_block_10_npu_b1.model",
                "modified_block_11_npu_b1.model",
                "modified_block_12_npu_b1.model",
                "modified_block_13_npu_b1.model",
                "modified_block_14_npu_b1.model",
                "modified_block_15_npu_b1.model",
                "modified_block_16_npu_b1.model",
                "modified_block_17_npu_b1.model",
                "modified_block_18_npu_b1.model",
                "modified_block_19_npu_b1.model",
                "modified_block_20_npu_b1.model",
                "modified_block_21_npu_b1.model",
                "modified_block_22_npu_b1.model",
                "modified_block_23_npu_b1.model"
            ],
            "logits": true,
            "logits_models": "lm_npu_b1.model",
            "tokenizer_file": "/opt/eswin/sample-code/npu_sample/qwen_sample/src/qwen2_0_5b/qwen.tiktoken",
            "embedding_file": "/opt/eswin/sample-code/npu_sample/qwen_sample/models/qwen2_0_5b/embedding.bin"
    3) Run es_qwen2
        cd /opt/eswin/sample-code/npu_sample/qwen_sample/bin/
        1) Run qwen2_0_5b
            ./es_qwen2 /opt/eswin/sample-code/npu_sample/qwen_sample/src/qwen2_0_5b/config.json
        2) Run qwen2_7b
            ./es_qwen2 /opt/eswin/sample-code/npu_sample/qwen_sample/src/qwen2_7b/config.json

5. Debug tools
    es_qwen2 support to enable debug functions through config.json. For example:
        "log_level": 0,
        "data_dump": 1,
        "data_dump_token": [10, 20],
        "perf_enable": 1,
        "op_dump": 1,
        "op_dump_token": [2, 8],
        "op_dump_layer": [1, 1],
        "op_dump_type": 1,
        "op_dump_list": [1, 10],
    "log_level": The log level, 0: error, 1: message 2:debug
    "data_dump": 1: Enbale dump token data, 0: Disable
    "data_dump_token": The token range of data dump.
    "perf_enable": 1: Enable print perfomance, 0: Disable.
    "op_dump": 1: Enbale dump operation data, 0: Disbale.
    "op_dump_token": The token range of operation dump.
    "op_dump_layer": The layer range of operation dump.
    "op_dump_type": Always set to 1.
    "op_dump_list": The operation range of operation dump

